/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/****************************************************************\
 *
 *--------------------------------------------------------------
 *
 *  File:comdef.h
 *
 *  Purpose: Common header file for definitions used in building
 *           install utilities,i.e. config,dspinstl,rspdspin.
 *
 *
 *
\****************************************************************/


/*
 *the following error codes are fatal
 *error codes that can be returned
 *by the display install response file
 *utility to the calling application
 */
#define  RSP_RETURN_GOOD            0
#define  RSP_INVALID_ARGUMENTS      1
#define  RSP_INVALID_ADAPTER_TYPE   2
#define  RSP_NO_MATCHING_DSC        3
#define  RSP_FILES_NOT_EXIST        4
#define  RSP_UNPACK_ERROR           5
#define  RSP_MEMORY_ERROR           6
#define  RSP_INIT_ERROR             7
#define  RSP_TRANSFER_THREAD_ERROR  8
#define  RSP_SOURCE_OLDER_DEST      9
#define  RSP_INVALID_RESP_FILE      10
#define  RSP_PRI_SEC_SAME           11
#define  RSP_NO_MATCHING_DSPS       12
#define  RSP_INVALID_DSP_FILE       13
#define  RSP_COPY_ERROR             14
#define  RSP_UPDATE_OS2INI_ERROR       15
#define  RSP_UPDATE_WININI_ERROR       16
#define  RSP_UPDATE_CONFIG_ERROR       17
#define  RSP_UPDATE_DRIVER_ERROR       18
#define  RSP_UPDATE_SETRES_ERROR       19
#define  RSP_SHAPI_INIT_ERROR          20
#define  RSP_UPDATE_WINDISKINS_ERROR   21                      //@FERENGI
#define  RSP_UPDATE_AUTOEXEC_ERROR     22

/*
 *the following arguments are used
 *by the display install response file
 *utility,passed on the command line
 */

#define  RSP_SOURCE_ARG                "S:"              //Source for dsps
#define  RSP_PRIMARYKEY_ARG            "PK:"             //Set the primary key
#define  RSP_SECONDARYKEY_ARG          "SK:"             //Set the secondary key
#define  RSP_RESPONSEFILE_NAME_ARG     "R:"              //Response file name
#define  RSP_DESTINATIONKEY_ARG        "T:"              //Destination drive
#define  RSP_LOGNAME_ARG               "L:"              //Log file name
#define  RSP_OVERRIDE_DATETIME         "ORDAT_TIM:"      //Override  date/time
                                                         //checking  ,default
                                                         //is not to check
                                                         //if source is older
                                                         //than destination
#define  RSP_MANUFACTURE_CODE         "MC:"              //Manufacturer code
#define  RSP_WINHANDLE                "H:"
#define  RSP_INS                      "INS:"             //called from install.exe warp
#define  RSP_PRIMDSCFILENAME          "PD:"     /* primary dsc file name */
#define  RSP_SECONDDSCFILENAME        "SD:"     /* secondary dsc file name */
#define  RSP_RESOLUTIONSTRING         "RES:"
#define  RSP_NVDMPARAMETER            "U"       //D99901




